const fs = require('fs');
const path = require('path');
const Redpack = require('weixin-redpack').Redpack;
const moment = require('moment');
const pify = require('pify');

module.exports = {
  async send(opts) {
    let { openid, amount, act, sender } = opts;
    act = act || '购物抽红包';
    let billNum =
      `huixuan${moment().format('YYYYMMDDHHmmsssss')}` +
      Math.random()
        .toString()
        .substr(2, 3);
    let redpack = Redpack({
      mch_id: '1437208902',
      partner_key: '03CF90756A431370E5B2614F6DEEDAAA',
      pfx: fs.readFileSync(path.join(__dirname, './certs/apiclient_cert.p12')),
      wxappid: 'wx88d545a5def0d88f'
    });
    let result = await pify(redpack.send).call(redpack, {
      mch_billno: billNum,
      send_name: sender || '惠选购物助手',
      wishing: act,
      re_openid: openid,
      total_amount: parseInt(amount * 100),
      total_num: 1,
      client_ip: '127.0.0.1',
      act_name: act
    });
    return result;
  }
};
